'use strict';
goog.provide('Blockly.Blocks.DEYI');
goog.require('Blockly.Blocks');  

// 读取MPU9250电子罗盘加速度传感器数据
Blockly.Blocks.mpu9250_readaccelxyz = {
    init: function () {

        this.appendDummyInput()
        .appendField(Blockly.Msg.MPU9250_READ_ACCEL);       
        this.appendValueInput('axname')
        .setCheck(null)
        .appendField('X:');
        this.appendValueInput('ayname')
        .setCheck(null)
        .appendField('Y:');
        this.appendValueInput('azname')
        .setCheck(null)
        .appendField('Z:');
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(40);
        this.setTooltip("");
        this.setHelpUrl("");
    }
};
// 读取MPU9250电子罗盘陀螺仪传感器数据
Blockly.Blocks.mpu9250_readgyroxyz = {
    init: function () {
        this.appendDummyInput("")
            .appendField(Blockly.Msg.MPU9250_READ_GYRO);
        this.appendValueInput('gxname')
        .setCheck(null)
        .appendField('X:');
        this.appendValueInput('gyname')
        .setCheck(null)
        .appendField('Y:');
        this.appendValueInput('gzname')
        .setCheck(null)
        .appendField('Z:');
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(40);
        this.setTooltip("");
        this.setHelpUrl("");
    }
};
// 读取MPU9250电子罗盘磁力计传感器数据
Blockly.Blocks.mpu9250_readmagnetxyz = {
    init: function () {
        this.appendDummyInput("")
            .appendField(Blockly.Msg.MPU9250_READ_MAGNET);
        this.appendValueInput('mxname')
        .setCheck(null)
        .appendField('X:');
        this.appendValueInput('myname')
        .setCheck(null)
        .appendField('Y:');
        this.appendValueInput('mzname')
        .setCheck(null)
        .appendField('Z:');
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(40);
        this.setTooltip("");
        this.setHelpUrl("");
    }
};
//三角函数atan2
Blockly.Blocks.math_atan2 = {
    init: function () {
        this.setColour(Blockly.Msg['MATH_HUE']);
        // this.setOutput(true, Number);
        this.appendDummyInput("")
            .appendField("atan2");   
        this.appendValueInput('param1')
            .setCheck(null)    
            .appendField('  ');    
        this.appendValueInput('param2')
            .setCheck(null)  
            .appendField('  ');   

        // this.setInputsInline(true);
        // this.setPreviousStatement(true, null);
        // this.setNextStatement(true, null);
        this.setInputsInline(true)
        this.setOutput(true, Number);
        this.setColour(40);
        this.setTooltip("");
        this.setHelpUrl("");
    }
};

// 创建UDP连接
Blockly.Blocks.net_udp_begin = {
    init: function () {
        this.appendDummyInput("")
            .appendField(Blockly.Msg.NET_UDP_BEGIN);
        this.appendValueInput('PORT')
        .setCheck(null)
        .appendField('PORT:');  
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(40);
        this.setTooltip("");
        this.setHelpUrl("");
    }
};
//发射UDP数据
Blockly.Blocks.net_udp_send = {
    init: function () {
        this.appendDummyInput("")
            .appendField(Blockly.Msg.NET_UDP_SEND);
        this.appendValueInput('IP')
        .setCheck(null)
        .appendField('IP:'); 
        this.appendValueInput('PORT')
        .setCheck(null)
        .appendField('port:');   
        this.appendValueInput('DATA')
        .setCheck(null)
        .appendField('data:');  
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(40);
        this.setTooltip("");
        this.setHelpUrl("");
    }
};

//读取UDP数据
Blockly.Blocks.net_udp_read = {
    init: function () {
        // this.appendDummyInput("")
        //     .appendField(Blockly.Msg.NET_UDP_Read); 
        // this.appendValueInput('BUF')
        // .setCheck(null)
        // .appendField('变量名:');       
        // this.setInputsInline(true);
        // this.setPreviousStatement(true, null);
        // this.setNextStatement(true, null);
        // this.setColour(40);
        // this.setTooltip("");
        // this.setHelpUrl("");
        this.setColour(Blockly.Msg['SERIAL_HUE']);
        this.appendValueInput("CONTENT", String)
            .appendField(Blockly.Msg.NET_UDP_Read)
            // .appendField(Blockly.Msg.MIXLY_SERIAL_PRINT)
            // .appendField(new Blockly.FieldDropdown([[Blockly.Msg.TEXT_PRINT_Huanhang_TOOLTIP, "println"], [Blockly.Msg.MIXLY_PRINT_INLINE, "print"]]), "new_line");
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setTooltip(Blockly.Msg.TEXT_PRINT_TOOLTIP);
    }
};
//读取UDP数据长度
Blockly.Blocks.net_udp_get_lenght = {
    init: function () {
        this.appendDummyInput("")
            .appendField(Blockly.Msg.NET_UDP_GET_LENGHT); 
        this.setInputsInline(true)
        this.setOutput(true,Number);
        this.setColour(40);
        this.setTooltip("");
        this.setHelpUrl("");
    }
};
//获取UDP远程连接IP地址
Blockly.Blocks.net_udp_get_remote_ip = {
    init: function () {
        this.appendDummyInput("")
            .appendField(Blockly.Msg.NET_UDP_GET_REMOTE_IP); 
        this.setInputsInline(true)
        this.setOutput(true,String);
        this.setColour(40);
        this.setTooltip("");
        this.setHelpUrl("");
    }
};

//获取UDP远程连接端口号
Blockly.Blocks.net_udp_get_remote_port = {
    init: function () {
        this.appendDummyInput("")
            .appendField(Blockly.Msg.NET_UDP_GET__REMOTE_PORT); 
        this.setInputsInline(true)
        this.setOutput(true,Number);
        this.setColour(40);
        this.setTooltip("");
        this.setHelpUrl("");
    }
};


//初始化LIS3MDL磁力计
Blockly.Blocks.lis3mdl_i2c_init = {
    init: function () {
        this.appendDummyInput("")
            .appendField(Blockly.Msg.LIS3MDL_I2C_BEGIN); 
        this.setInputsInline(true)
        this.setOutput(true,Boolean);
        this.setColour(40);
        this.setTooltip("");
        this.setHelpUrl("");
    }
};

// 刷新LIS3MDL磁力值
Blockly.Blocks.lis3mdl_read_magnet_value = {
    init: function () {
        this.appendDummyInput()
        .appendField(Blockly.Msg.LIS3MDL_I2C_READ);
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(40);
        this.setTooltip("");
        this.setHelpUrl("");
    }
};

// 刷新LIS3MDL磁力值
Blockly.Blocks.lis3mdl_read_magnet_xyz = {
    init: function () {
        this.setColour(40);
        this.appendDummyInput()
        .appendField(Blockly.Msg.LIS3MDL_I2C_READ_MEGNETXYZ)
        .appendField(new Blockly.FieldDropdown([ 
            [Blockly.Msg.LIS3MDL_X, "mag.m.x"],
            [Blockly.Msg.LIS3MDL_Y, "mag.m.y"],
            [Blockly.Msg.LIS3MDL_Z, "mag.m.z"],
           ]), "INDEX")
        this.setInputsInline(true)
        this.setOutput(true,Number);       
        this.setTooltip("");
        this.setHelpUrl("");
    }
};
