
'use strict'; 
goog.require('Blockly.Arduino');
goog.require('Mixly.Config');

// QMC5883L电子罗盘模块刷新数据
Blockly.Arduino.forBlock['mpu9250_readaccelxyz'] = function() {
    Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
    Blockly.Arduino.definitions_['include_FaBo9Axis_MPU9250'] = '#include <FaBo9Axis_MPU9250.h>';
    Blockly.Arduino.definitions_['var_declare_FaBo9Axis'] = 'FaBo9Axis fabo_9axis;\nfloat ax,ay,az,gx,gy,gz,mx,my,mz;';
    Blockly.Arduino.setups_['setup_fabo_9axis'] = 'fabo_9axis.begin();';

    let ax = Blockly.Arduino.valueToCode(this, 'axname', Blockly.Arduino.ORDER_ATOMIC);
    let ay = Blockly.Arduino.valueToCode(this, 'ayname', Blockly.Arduino.ORDER_ATOMIC);
    let az = Blockly.Arduino.valueToCode(this, 'azname', Blockly.Arduino.ORDER_ATOMIC);
    var code = 'fabo_9axis.readAccelXYZ(&' + ax + ',&'  + ay + ',&'  + az + ');\n';
    return code;
};

// QMC5883L电子罗盘模块获取方位角
Blockly.Arduino.forBlock['mpu9250_readgyroxyz'] = function() {
    Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
    Blockly.Arduino.definitions_['include_FaBo9Axis_MPU9250'] = '#include <FaBo9Axis_MPU9250.h>';
    Blockly.Arduino.definitions_['var_declare_FaBo9Axis'] = 'FaBo9Axis fabo_9axis;\nfloat ax,ay,az,gx,gy,gz,mx,my,mz;';
    Blockly.Arduino.setups_['setup_fabo_9axis'] = 'fabo_9axis.begin();';
    let gx = Blockly.Arduino.valueToCode(this, 'gxname', Blockly.Arduino.ORDER_ATOMIC);
    let gy = Blockly.Arduino.valueToCode(this, 'gyname', Blockly.Arduino.ORDER_ATOMIC);
    let gz = Blockly.Arduino.valueToCode(this, 'gzname', Blockly.Arduino.ORDER_ATOMIC);
    var code = 'fabo_9axis.readGyroXYZ(&' + gx + ',&' + gy + ',&'  + gz + ');\n';
    return code;
};

// QMC5883L电子罗盘模块获取方位角
Blockly.Arduino.forBlock['mpu9250_readmagnetxyz'] = function() {
    Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
    Blockly.Arduino.definitions_['include_FaBo9Axis_MPU9250'] = '#include <FaBo9Axis_MPU9250.h>';
    Blockly.Arduino.definitions_['var_declare_FaBo9Axis'] = 'FaBo9Axis fabo_9axis;\nfloat ax,ay,az,gx,gy,gz,mx,my,mz;';
    Blockly.Arduino.setups_['setup_fabo_9axis'] = 'fabo_9axis.begin();';
    let mx = Blockly.Arduino.valueToCode(this, 'mxname', Blockly.Arduino.ORDER_ATOMIC);
    let my = Blockly.Arduino.valueToCode(this, 'myname', Blockly.Arduino.ORDER_ATOMIC);
    let mz = Blockly.Arduino.valueToCode(this, 'mzname', Blockly.Arduino.ORDER_ATOMIC);
    var code = 'fabo_9axis.readMagnetXYZ(&' + mx + ',&'  + my + ',&'  + mz + ');\n';
    return code;
};

Blockly.Arduino.forBlock['math_atan2'] = function() {
    var argument0 = Blockly.Arduino.valueToCode(this, 'param1',
    Blockly.Arduino.ORDER_NONE) || '0';
    var argument1 = Blockly.Arduino.valueToCode(this, 'param2',
        Blockly.Arduino.ORDER_NONE) || '0';
    var code = 'atan2(' + argument0 + ',' + argument1 +')' ;
    return [code, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.forBlock['net_udp_begin'] = function() {
    Blockly.Arduino.definitions_['include_Wifi'] = '#include <WiFi.h>';
    Blockly.Arduino.definitions_['var_WiFiUDP_Udp'] = 'WiFiUDP Udp;';
    let port = Blockly.Arduino.valueToCode(this, 'PORT', Blockly.Arduino.ORDER_ATOMIC);
    var code = 'Udp.begin(' +port +');\n';
    return code;
};
Blockly.Arduino.forBlock['net_udp_send'] = function() {
    Blockly.Arduino.definitions_['include_Wifi'] = '#include <WiFi.h>';
    Blockly.Arduino.definitions_['var_WiFiUDP_Udp'] = 'WiFiUDP Udp;';
    let ip = Blockly.Arduino.valueToCode(this, 'IP', Blockly.Arduino.ORDER_ATOMIC);
    let port = Blockly.Arduino.valueToCode(this, 'PORT', Blockly.Arduino.ORDER_ATOMIC);
    let data = Blockly.Arduino.valueToCode(this, 'DATA', Blockly.Arduino.ORDER_ATOMIC);
    var code = 'Udp.beginPacket(' + ip +',' + port +');\nUdp.print(' + data +');\nUdp.endPacket();\n';
    return code;
};
Blockly.Arduino.forBlock['net_udp_read'] = function() {
    Blockly.Arduino.definitions_['include_Wifi'] = '#include <WiFi.h>';
    Blockly.Arduino.definitions_['var_WiFiUDP_Udp'] = 'WiFiUDP Udp;';
    let buf = Blockly.Arduino.valueToCode(this, 'CONTENT', Blockly.Arduino.ORDER_ATOMIC); 
    // Blockly.Arduino.definitions_['var_WiFiUDP_myData'] = 'char * myData = "";\n';       
    var code = 'int _udppacketSize = Udp.parsePacket();\n'; 
    code += 'char ' + buf + '[_udppacketSize];\n';
    code += 'Udp.read(' + buf + ',_udppacketSize);\n';
    return code;
};
Blockly.Arduino.forBlock['net_udp_get_lenght'] = function() {
    Blockly.Arduino.definitions_['include_Wifi'] = '#include <WiFi.h>';
    Blockly.Arduino.definitions_['var_WiFiUDP_Udp'] = 'WiFiUDP Udp;';
    var code = 'Udp.parsePacket()';
    return [code, Blockly.Arduino.ORDER_ATOMIC];
};
Blockly.Arduino.forBlock['net_udp_get_remote_ip'] = function() {
    Blockly.Arduino.definitions_['include_Wifi'] = '#include <WiFi.h>';
    Blockly.Arduino.definitions_['var_WiFiUDP_Udp'] = 'WiFiUDP Udp;';
    var code = 'Udp.remoteIP()';
    return [code, Blockly.Arduino.ORDER_ATOMIC];
};
Blockly.Arduino.forBlock['net_udp_get_remote_port'] = function() {
    Blockly.Arduino.definitions_['include_Wifi'] = '#include <WiFi.h>';
    Blockly.Arduino.definitions_['var_WiFiUDP_Udp'] = 'WiFiUDP Udp;';
    var code = 'Udp.remotePort()';
    return [code, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.forBlock['lis3mdl_i2c_init'] = function() {
    Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h> ';  
    Blockly.Arduino.definitions_['include_LIS3MDL'] = '#include <LIS3MDL.h> '; 
    Blockly.Arduino.setups_['setup_wire_begin'] = 'Wire.begin();';
    Blockly.Arduino.definitions_['var_declare_LIS3MDL_mag'] = 'LIS3MDL mag;';
    var code = 'mag.init()';
    return [code, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.forBlock['lis3mdl_read_magnet_value'] = function() {
    Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h> ';  
    Blockly.Arduino.definitions_['include_LIS3MDL'] = '#include <LIS3MDL.h> ';
    Blockly.Arduino.definitions_['var_declare_LIS3MDL_mag'] = 'LIS3MDL mag;';  
    Blockly.Arduino.setups_['setup_wire_begin'] = 'Wire.begin();';
    Blockly.Arduino.setups_['setup_lis3mdl_begin'] =  'if (!mag.init())\n'
                                                    + '\t{\n'
                                                    + '\t\tSerial.println("Failed to detect and initialize magnetometer!");\n'
                                                    + '\t\twhile(1);\n'
                                                    + '\t}\n'
                                                    + '\tmag.enableDefault();\n';
    var code = 'mag.read();\n'; 
    return code;
};

Blockly.Arduino.forBlock['lis3mdl_read_magnet_xyz'] = function() {
    Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h> ';  
    Blockly.Arduino.definitions_['include_LIS3MDL'] = '#include <LIS3MDL.h> '; 
    Blockly.Arduino.definitions_['var_declare_LIS3MDL_mag'] = 'LIS3MDL mag;';
    Blockly.Arduino.setups_['setup_wire_begin'] = 'Wire.begin();';
    Blockly.Arduino.setups_['setup_lis3mdl_begin'] =  'if (!mag.init())\n'
                                                    + '\t{\n'
                                                    + '\t\tSerial.println("Failed to detect and initialize magnetometer!");\n'
                                                    + '\t\twhile(1);\n'
                                                    + '\t}\n'
                                                    + '\tmag.enableDefault();\n';

    var index = this.getFieldValue('INDEX'); 
    var code = '(' + index + '/ 6842.0)' ; 
    return [code, Blockly.Arduino.ORDER_ATOMIC];
};
